commit c4b6cd19106c7866a0446815a54e8551141512ed
Author: Jeremy Harris <jgh146exb@wizmail.org>
Date:   Fri Jan 23 14:38:26 2026 +0000

    Debug: wordsize mods follow-up
    
    Broken-by: c33264393a1c

diff --git a/src/exim_monitor/em_version.c b/src/exim_monitor/em_version.c
index 15b16c10f..aac3788cd 100644
--- a/src/exim_monitor/em_version.c
+++ b/src/exim_monitor/em_version.c
@@ -9,12 +9,13 @@
 
 #define EM_VERSION_C
 
+#include <string.h>
+#include <stdint.h>
+#include <stdlib.h>
 #include "mytypes.h"
 #include "store.h"
 #include "path_max.h"
 #include "macros.h"
-#include <string.h>
-#include <stdlib.h>
 
 #include "version.h"
 
diff --git a/src/src/functions.h b/src/src/functions.h
index 916c1a329..3614ebfca 100644
--- a/src/src/functions.h
+++ b/src/src/functions.h
@@ -140,7 +140,7 @@ extern int     bdat_ungetc(int);
 extern void    bdat_flush_data(void);
 
 extern void    bits_clear(unsigned long *, size_t, int *);
-extern void    bits_set(unsigned long *, size_t, int *);
+extern void    bits_set(bitmask_word_t *, size_t, int *);
 
 extern void    cancel_cutthrough_connection(BOOL, const uschar *);
 extern gstring *cat_file(FILE *, gstring *, const uschar *);
diff --git a/src/src/macros.h b/src/src/macros.h
index ea5ca9277..0efe34cc0 100644
--- a/src/src/macros.h
+++ b/src/src/macros.h
@@ -371,7 +371,16 @@ masks are part of the local_scan API so are #defined in local_scan.h .
 Thanks to the "one word", debug bits beyond 31 are not available on 32b-int
 systems, and coding must account for that. */
 
-#define DEBUG_BIT(name) Di_##name = IOTA(Di_iota), D_##name = (unsigned long)BIT(Di_##name)
+#ifndef bitmask_word_t
+# define bitmask_word_t          uint64_t
+#endif
+
+#define BITMASK_IDX_TO_BIT(idx) ((bitmask_word_t)1 << (idx))
+#define BIT_TABLE_BIT(class, name) \
+			class##i_##name = IOTA(class##i_iota), \
+			class##_##name = BITMASK_IDX_TO_BIT(class##i_##name)
+
+#define DEBUG_BIT(name) BIT_TABLE_BIT(D, name)
 #define DEBUG_Z_BIT(name) Di_##name = 0, D_##name = 0
 
 enum {
@@ -455,7 +464,7 @@ and are only ever tested independently, so they do not need bit mask
 declarations. The Li_all value is recognized specially by decode_bits().
 Add also to log_options[] when creating new ones. */
 
-#define LOG_BIT(name) Li_##name = IOTA(Li_iota), L_##name = BIT(Li_##name)
+#define LOG_BIT(name) BIT_TABLE_BIT(L, name)
 
 enum logbit {
   Li_all = -1,

